Unit DE13R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE10_p;

procedure DE13R(F :Proc_F_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; HMIN :Real;
                EPS :Real; P :Real; var H :Real; var Y :Array of Real;
                var YP :Array of Real; var DELTY :Array of Real;
                var YR :Array of Real; var DY :Array of Real;
                var IERR :Integer);

implementation

procedure DE13R(F :Proc_F_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; HMIN :Real;
                EPS :Real; P :Real; var H :Real; var Y :Array of Real;
                var YP :Array of Real; var DELTY :Array of Real;
                var YR :Array of Real; var DY :Array of Real;
                var IERR :Integer);
var
E,BB :Integer;
B,C,U,V,Z,BC :Real;
A,W,BUL :Boolean;
BD :Array [0..3] of Real;
BE :Array [0..2] of Real;
BF :Array [0..2] of Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
{   DATA  FORTRAN  }
BD[0] := 0.1666666666666667e0;
BD[1] := 0.3333333333333333e0;
BD[2] := 0.3333333333333333e0;
BD[3] := 0.1666666666666667e0;
BE[0] := 0.5e0;
BE[1] := 0.5e0;
BE[2] := 1.0e0;
BF[0] := -1.0e0;
BF[1] := -1.0e0;
BF[2] := 1.0e0;
IERR := 0;
B := 32.0;
C := XN;
for E:=1 to M do
 begin
  Y[E-1] := YN[E-1];
_1:
 end;
if ( XN = XK ) 
 then goto _15;
A := False;
BUL := False;
H := Sign(H,XK-XN);

_2:
if ( not A ) 
 then goto _3;
H := U;

goto _15;
_3:
V := XK-C;
if ( Abs(V) > Abs(H) ) 
 then goto _4;
U := H;
A := True;
H := V;
_4:
BC := C;
for E:=1 to M do
 begin
  YP[E-1] := Y[E-1];
  YR[E-1] := Y[E-1];
_5:
 end;
F(C,YR[0],DY[0],M);
for E:=1 to M do
 begin
  DY[E-1] := H*DY[E-1];
  Y[E-1] := Y[E-1]+BD[0]*DY[E-1];
  DELTY[E-1] := DY[E-1];
_6:
 end;
for BB:=1 to 3 do
 begin
  C := BC+BE[BB-1]*H;
  for E:=1 to M do
   begin
    YR[E-1] := YP[E-1]+BE[BB-1]*DY[E-1];
_7:
   end;
  F(C,YR[0],DY[0],M);
  for E:=1 to M do
   begin
    DY[E-1] := H*DY[E-1];
    Y[E-1] := Y[E-1]+BD[BB+0]*DY[E-1];
    DELTY[E-1] := DELTY[E-1]+BF[BB-1]*DY[E-1];
_8:
   end;
_9:
 end;
C := BC+H;
W := True;
for E:=1 to M do
 begin
  Z := Abs(Y[E-1]);
  if ( Z < P ) 
   then goto _10;
  DELTY[E-1] := DELTY[E-1]/Y[E-1];
_10:
 end;
for E:=1 to M do
 begin
  Z := Abs(DELTY[E-1]);
  if ( Z > EPS ) 
   then goto _12;
  if ( not W ) 
   then goto _11;
  if ( B*Z < EPS ) 
   then goto _11;
  W := False;
_11:
 end;
if ( W ) 
 then H := 2.0*H;
goto _2;
_12:
for E:=1 to M do
 begin
  Y[E-1] := YP[E-1];
_13:
 end;
if ( BUL ) 
 then goto _14;
C := C-H;
H := 0.5*H;
A := False;
if ( Abs(H) >= HMIN ) 
 then goto _4;
H := Sign(HMIN,H);
BUL := True;
goto _4;
_14:
IERR := 65;
UTDE10(IERR,13);
_15:
end;

end.
